CodeForces - 1579G Minimal Coverage(dp)
Posted Frozen_Guardian
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了CodeForces - 1579G Minimal Coverage(dp)相关的知识,希望对你有一定的参考价值。
题目链接:点击查看
题目大意:给出 n n n 个长度不同的木棍。设第 i − 1 i-1 i−1 次放置木棍后的终点为 x x x,那么第 i i i 个木棍有且仅有两种放置方法:
- 放到 [ x + 1 , x + a [ i ] ] [x+1,x+a[i]] [x+1,x+a[i]],终点变为 x + a [ i ] x+a[i] x+a[i]
- 放到 [ x − a [ i ] , x − 1 ] [x-a[i],x-1] [x−a[i],x−1],终点变为 x − a [ i ] x-a[i] x−a[i]
问如何放置可以使得被覆盖的端点数最少
题目分析:读懂题后不难想到 2 n 2^n 2n 去暴力枚举,进而想到要用 d p dp dp 优化求解。
所以可以大胆设置 d p [ i ] [ j ] dp[i][j] dp[i][j] 为放置了前 i i i 个木棍后,终点为 j j j 时的答案(最少的被覆盖的端点数量)。思考过后发现,因为每根木棍的长度最大是 1000 1000 1000,所以 j ∈ [ − 1000 , 1000 ] j\\in[-1000,1000] j∈[−1000,1000]。
还有一个问题就是如何计算转移过程中的答案。如果覆盖的区间为 [ l , r ] [l,r] [l,r],其中 l l l 和 r r r 都不等于 0 0 0 的话,状态转移起来将非常困难。
看了题解后,意识到我们只需要关心相对位置即可,如果 [ l , r ] [l,r] [l,r] 都不等于 0 0 0 的话,偏移一下就好啦。
将 d p dp dp 方程的定义重新改为:放置了前 i i i 个木棍后,终点距离左端点的距离为 j j j 时的答案。
代码:
// Problem: G. Minimal Coverage
// Contest: Codeforces - Codeforces Round #744 (Div. 3)
// URL: https://codeforces.com/contest/1579/problem/G
// Memory Limit: 256 MB
// Time Limit: 1000 ms
//
// Powered by CP Editor (https://cpeditor.org)
// #pragma GCC optimize(2)
// #pragma GCC optimize("Ofast","inline","-ffast-math")
// #pragma GCC target("avx,sse2,sse3,sse4,mmx")
#include<iostream>
#include<cstdio>
#include<string>
#include<ctime>
#include<cmath>
#include<cstring>
#include<algorithm>
#include<stack>
#include<climits>
#include<queue>
#include<map>
#include<set>
#include<sstream>
#include<cassert>
#include<bitset>
#include<list>
#include<unordered_map>
#define lowbit(x) (x&-x)
using namespace std;
typedef long long LL;
typedef unsigned long long ull;
template<typename T>
inline void read(T &x)
T f=1;x=0;
char ch=getchar();
while(0==isdigit(ch))if(ch=='-')f=-1;ch=getchar();
while(0!=isdigit(ch)) x=(x<<1)+(x<<3)+ch-'0',ch=getchar();
x*=f;
template<typename T>
inline void write(T x)
if(x<0)x=~(x-1);putchar('-');
if(x>9)write(x/10);
putchar(x%10+'0');
const int inf=0x3f3f3f3f;
const int N=1e4+100;
const int M=2e3+100;
int a[N];
int dp[N][M];
int main()
#ifndef ONLINE_JUDGE
// freopen("data.in.txt","r",stdin);
// freopen("data.out.txt","w",stdout);
#endif
// ios::sync_with_stdio(false);
int w;
cin>>w;
while(w--)
int n;
read(n);
for(int i=1;i<=n;i++)
read(a[i]);
memset(dp[i],inf,sizeof(dp[i]));
dp[1][a[1]]=a[1];
for(int i=2;i<=n;i++)
for(int j=0;j<M;j++)
//[j+1,j+a[i]]
if(j+a[i]<M)
dp[i][j+a[i]]=min(dp[i][j+a[i]],max(dp[i-1][j],j+a[i]));
//[j-a[i],j-1]
if(j-a[i]>=0)
dp[i][j-a[i]]=min(dp[i][j-a[i]],dp[i-1][j]);
else
dp[i][0]=min(dp[i][0],a[i]-j+dp[i-1][j]);
cout<<*min_element(dp[n],dp[n]+M)<<endl;
return 0;
以上是关于CodeForces - 1579G Minimal Coverage(dp)的主要内容,如果未能解决你的问题,请参考以下文章
CodeForces - 1579G Minimal Coverage(dp)
CodeForces - 1579G Minimal Coverage(dp)